# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class PostWorkflowOptionsDefaults(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PostWorkflowOptionsDefaults - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'node_id': 'str',
            'graph_options': 'object'
        }

        self.attribute_map = {
            'node_id': 'nodeId',
            'graph_options': 'graphOptions'
        }

        self._node_id = None
        self._graph_options = None

    @property
    def node_id(self):
        """
        Gets the node_id of this PostWorkflowOptionsDefaults.


        :return: The node_id of this PostWorkflowOptionsDefaults.
        :rtype: str
        """
        return self._node_id

    @node_id.setter
    def node_id(self, node_id):
        """
        Sets the node_id of this PostWorkflowOptionsDefaults.


        :param node_id: The node_id of this PostWorkflowOptionsDefaults.
        :type: str
        """
        self._node_id = node_id

    @property
    def graph_options(self):
        """
        Gets the graph_options of this PostWorkflowOptionsDefaults.


        :return: The graph_options of this PostWorkflowOptionsDefaults.
        :rtype: object
        """
        return self._graph_options

    @graph_options.setter
    def graph_options(self, graph_options):
        """
        Sets the graph_options of this PostWorkflowOptionsDefaults.


        :param graph_options: The graph_options of this PostWorkflowOptionsDefaults.
        :type: object
        """
        self._graph_options = graph_options

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

