# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Skus20SkusUpsert(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Skus20SkusUpsert - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'discovery_graph_name': 'str',
            'discovery_graph_options': 'object',
            'name': 'str',
            'rules': 'list[TagRule]'
        }

        self.attribute_map = {
            'discovery_graph_name': 'discoveryGraphName',
            'discovery_graph_options': 'discoveryGraphOptions',
            'name': 'name',
            'rules': 'rules'
        }

        self._discovery_graph_name = None
        self._discovery_graph_options = None
        self._name = None
        self._rules = None

    @property
    def discovery_graph_name(self):
        """
        Gets the discovery_graph_name of this Skus20SkusUpsert.


        :return: The discovery_graph_name of this Skus20SkusUpsert.
        :rtype: str
        """
        return self._discovery_graph_name

    @discovery_graph_name.setter
    def discovery_graph_name(self, discovery_graph_name):
        """
        Sets the discovery_graph_name of this Skus20SkusUpsert.


        :param discovery_graph_name: The discovery_graph_name of this Skus20SkusUpsert.
        :type: str
        """
        self._discovery_graph_name = discovery_graph_name

    @property
    def discovery_graph_options(self):
        """
        Gets the discovery_graph_options of this Skus20SkusUpsert.


        :return: The discovery_graph_options of this Skus20SkusUpsert.
        :rtype: object
        """
        return self._discovery_graph_options

    @discovery_graph_options.setter
    def discovery_graph_options(self, discovery_graph_options):
        """
        Sets the discovery_graph_options of this Skus20SkusUpsert.


        :param discovery_graph_options: The discovery_graph_options of this Skus20SkusUpsert.
        :type: object
        """
        self._discovery_graph_options = discovery_graph_options

    @property
    def name(self):
        """
        Gets the name of this Skus20SkusUpsert.


        :return: The name of this Skus20SkusUpsert.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Skus20SkusUpsert.


        :param name: The name of this Skus20SkusUpsert.
        :type: str
        """
        self._name = name

    @property
    def rules(self):
        """
        Gets the rules of this Skus20SkusUpsert.
        Possible Rules a Sku can use

        :return: The rules of this Skus20SkusUpsert.
        :rtype: list[TagRule]
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """
        Sets the rules of this Skus20SkusUpsert.
        Possible Rules a Sku can use

        :param rules: The rules of this Skus20SkusUpsert.
        :type: list[TagRule]
        """
        self._rules = rules

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

